#!/usr/bin/env node

var W = 1920;
var H = 1080;

var numW = 11;
var numH = 4;

var keyX = W / numW;
var keyY = H / numH;
var offsets = [
	0,
	keyX / 2,
	keyX / 1.9,
	0
];

var map = {};

[
	[ 10,  0, 0 ], // 1
	[ 11,  1, 0 ],
	[ 12,  2, 0 ],
	[ 13,  3, 0 ],
	[ 14,  4, 0 ],
	[ 15,  5, 0 ],
	[ 16,  6, 0 ],
	[ 17,  7, 0 ],
	[ 18,  8, 0 ],
	[ 19,  9, 0 ],
	[ 20, 10, 0 ],
	[ 21, 11, 0 ],

	[ 24,  0, 1 ], // q
	[ 25,  1, 1 ],
	[ 26,  2, 1 ],
	[ 27,  3, 1 ],
	[ 28,  4, 1 ],
	[ 29,  5, 1 ],
	[ 30,  6, 1 ],
	[ 31,  7, 1 ],
	[ 32,  8, 1 ],
	[ 33,  9, 1 ],
	[ 34, 10, 1 ],
	[ 35, 11, 1 ],

	[ 38,  0, 2 ], // a
	[ 39,  1, 2 ],
	[ 40,  2, 2 ],
	[ 41,  3, 2 ],
	[ 42,  4, 2 ],
	[ 43,  5, 2 ],
	[ 44,  6, 2 ],
	[ 45,  7, 2 ],
	[ 46,  8, 2 ],
	[ 47,  9, 2 ],
	[ 48, 10, 2 ],
	[ 51, 11, 2 ],

	[ 94,  0, 3 ], // <
	[ 52,  1, 3 ],
	[ 53,  2, 3 ],
	[ 54,  3, 3 ],
	[ 55,  4, 3 ],
	[ 56,  5, 3 ],
	[ 57,  6, 3 ],
	[ 58,  7, 3 ],
	[ 59,  8, 3 ],
	[ 60,  9, 3 ],
	[ 61, 10, 3 ]
].forEach(key => {
	var k = key[0];
	var x = key[1];
	var y = key[2];

	map[k.toString()] = [
		Math.round((x * keyX) + offsets[y]),
		Math.round((y * keyY) + keyY / 2)
	];
});

var spawn = require("child_process").spawn;

var child = spawn("./listener.sh");

function mouse(x, y) {
	spawn("xdotool", [
		"mousemove",
		x, y
	]);
}

child.stdout.on("data", d => {
	var str = d.toString().trim();
	var key = map[str];
	if (key === undefined)
		return;

	mouse(key[0], key[1]);
});

function onTerm() {
	child.kill();
	process.exit(1);
}
process.on("SIGTERM", onTerm);
process.on("SIGINT", onTerm);
